Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC
Bug 468388 - Improvements for net-wireless/broadcom-sta-5.100.82.112
Summary: Improvements for net-wireless/broadcom-sta-5.100.82.112
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: New packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: M. B.
URL:
Whiteboard:
Keywords:
Depends on: 306189 399747 407667 437898 459208
Blocks:
  Show dependency tree
 
Reported: 2013-05-03 09:55 UTC by M. B.
Modified: 2013-05-12 10:52 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
broadcom-sta-5.100.82.112-r3.ebuild (broadcom-sta-5.100.82.112-r3.ebuild,2.78 KB, text/plain)
2013-05-03 09:55 UTC, M. B.
Details
broadcom-sta-5.100.82.112-linux-3.2-with-multicast.patch (broadcom-sta-5.100.82.112-linux-3.2-with-multicast.patch,428 bytes, patch)
2013-05-03 10:02 UTC, M. B.
Details | Diff
broadcom-sta-5.100.82.112-linux-3.4.patch (broadcom-sta-5.100.82.112-linux-3.4.patch,355 bytes, patch)
2013-05-03 10:02 UTC, M. B.
Details | Diff
broadcom-sta-5.100.82.112-linux-3.6.patch (broadcom-sta-5.100.82.112-linux-3.6.patch,2.25 KB, patch)
2013-05-03 10:03 UTC, M. B.
Details | Diff
broadcom-sta-5.100.82.112-linux-3.8.patch (broadcom-sta-5.100.82.112-linux-3.8.patch,2.44 KB, patch)
2013-05-03 10:03 UTC, M. B.
Details | Diff
broadcom-sta-5.100.82.112-linux-3.9.patch (broadcom-sta-5.100.82.112-linux-3.9.patch,420 bytes, patch)
2013-05-03 10:04 UTC, M. B.
Details | Diff
broadcom-sta-5.100.82.112-remove-rssi-errors.patch (broadcom-sta-5.100.82.112-remove-rssi-errors.patch,1.25 KB, patch)
2013-05-03 10:05 UTC, M. B.
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description M. B. 2013-05-03 09:55:38 UTC
Created attachment 347212 [details]
broadcom-sta-5.100.82.112-r3.ebuild

broadcom-sta-5.100.82.112 has long had several outstanding issues. I propose this ebuild as broadcom-sta-5.100.82.112-r3.ebuild.

You can track my work in the tbc overlay.

The following issues have been fixed:
bug #306189 - a non-fatal check was introduced to warn against CONFIG_LIB80211_CRYPT_TKIP not being selected, which renders WPA functionality unavailable. This affects almost all recent routers.

Additional explanatory messages were added for various CONFIG_CHECKS.

check_kernel_built from linux-info.eclass gets called in order to make sure the kernel is ready to deal with external modules.

bug #407667 - replaced broadcom-sta-5.100.82.112-linux-3.2.patch with a similar patch that preserves multicast functionality. Can be found in the bugreport.

style issue: converted the sed in the ebuild for working with kernel 3.4 into patch file broadcom-sta-5.100.82.112-linux-3.4.patch, so it can actually fail if it doesn't fit anymore

bug #437898 - kernel oops upon loading with kernel 3.6 and later. It refers to a patch on https://bugzilla.rpmfusion.org/show_bug.cgi?id=2526 to fix the issue. This patch is incorporated in broadcom-sta-5.100.82.112-linux-3.6.patch, along with other adaptations. The patch actually loaded in this ebuild is identical to https://github.com/Sabayon/for-gentoo/blob/master/net-wireless/broadcom-sta/files/broadcom-sta-5.100.82.112-linux-3.6.patch

bug #459208 - attached patch gets loaded as broadcom-sta-5.100.82.112-linux-3.8.patch, makes it work with kernel 3.8

another patch from sabayon: "lxnay 2 days ago [net-wireless/broadcom-sta] more Linux 3.9 love, wheeeee" - gets loaded as broadcom-sta-5.100.82.112-linux-3.9.patch

bug #399747 - broadcom-sta-5.100.82.112-remove-rssi-errors.patch - silences EINVAL errors and is not actually a fix.

IMPORTANT NOTICE:
This ebuild was tested to compile fine against the following kernels:
linux-3.0.35-gentoo
linux-3.0.75-gentoo
linux-3.2.44-gentoo
linux-3.4.34-gentoo
linux-3.4.42-gentoo
linux-3.5.7-gentoo
linux-3.6.11-gentoo-r1
linux-3.7.10-gentoo-r1
linux-3.8.10-gentoo
linux-3.8.3-gentoo-r1
linux-3.8.4-gentoo
linux-3.8.5-gentoo
linux-3.8.6-gentoo
linux-3.8.7-gentoo
linux-3.8.8-gentoo
linux-3.8.9-gentoo
linux-3.9.0-gentoo

It was tested to load fine with
linux-3.8.10-gentoo
linux-3.7.10-gentoo-r1

However, i do get frequent disconnect/reconnects without ever obtaining an IP address with anything beyond kernel 3.5. Since I have the same problem with brcmsmac, I will need to further investigate.
Please comment if you get similar/different results.
My hardware is a BCM4313 [14e4:4727] (rev 01).
Comment 1 M. B. 2013-05-03 10:02:01 UTC
Created attachment 347218 [details, diff]
broadcom-sta-5.100.82.112-linux-3.2-with-multicast.patch
Comment 2 M. B. 2013-05-03 10:02:49 UTC
Created attachment 347220 [details, diff]
broadcom-sta-5.100.82.112-linux-3.4.patch
Comment 3 M. B. 2013-05-03 10:03:27 UTC
Created attachment 347222 [details, diff]
broadcom-sta-5.100.82.112-linux-3.6.patch
Comment 4 M. B. 2013-05-03 10:03:58 UTC
Created attachment 347224 [details, diff]
broadcom-sta-5.100.82.112-linux-3.8.patch
Comment 5 M. B. 2013-05-03 10:04:34 UTC
Created attachment 347226 [details, diff]
broadcom-sta-5.100.82.112-linux-3.9.patch
Comment 6 M. B. 2013-05-03 10:05:20 UTC
Created attachment 347228 [details, diff]
broadcom-sta-5.100.82.112-remove-rssi-errors.patch
Comment 7 M. B. 2013-05-03 10:09:58 UTC
The files pasted here so far are the new files i added to (and are identical with the ones in) my commit 86a1ace73a9f6ae59ba442c957dfc7af59d70dcd in the tbc overlay.
Comment 8 Sergey Popov gentoo-dev 2013-05-12 10:52:59 UTC
+*broadcom-sta-5.100.82.112-r3 (12 May 2013)
+
+  12 May 2013; Sergey Popov <pinkbyte@gentoo.org>
+  +broadcom-sta-5.100.82.112-r3.ebuild,
+  +files/broadcom-sta-5.100.82.112-linux-3.2-with-multicast.patch,
+  +files/broadcom-sta-5.100.82.112-linux-3.4.patch,
+  +files/broadcom-sta-5.100.82.112-linux-3.6.patch,
+  +files/broadcom-sta-5.100.82.112-linux-3.8.patch,
+  +files/broadcom-sta-5.100.82.112-linux-3.9.patch,
+  +files/broadcom-sta-5.100.82.112-remove-rssi-errors.patch:
+  Revision bump: add compatibility with more kernel versions, wrt bugs #437898
+  and #468388, thanks to M. B. <tomboy64 AT sina.cn>